import java.util.*;
import java.io.*;

class SeznamH{
	
	static Graf graf;	//vytvoreni promenne pro reprezentaci grafu
	
	public static void main(String[] args){
		System.out.println("Graf zadany seznamem sousednosti - prohledavani do hloubky");
		
		char znovu='a';
		while(znovu=='a' || znovu=='A'){	//cyklus pro opakovani zadani
			vstup();	//volani metody pro nacteni dat
			
			while(znovu=='a' || znovu=='A'){	//cyklus pro opakovani hledani
				for(int i=0; i<graf.vrcholy.length; i++) graf.vrcholy[i].barva='b';	//obarveni vsech vrcholu na bilo
				
				System.out.println("\nHledani zahajit od vrcholu cislo: ");
				int cislo=Integer.parseInt(nacti());
				
				System.out.print("\nNalezene vrcholy: ");
				
				DFS(cislo);		//volani metody pro hledani
				
				System.out.println("\nDalsi hledani (a/n): ");
				znovu=nacti().charAt(0);
			}
			
			System.out.println("\nDalsi zadani (a/n): ");
			znovu=nacti().charAt(0);
		}
	}

	public static void vstup(){
		System.out.println("\nZadejte pocet vrcholu: ");
		graf=new Graf(Integer.parseInt(nacti()));	//nacteni poctu vrcholu
		
		for(int i=0; i<graf.vrcholy.length; i++){	//cyklus pro nacteni seznamu sousednosti
			graf.vrcholy[i]=new Vrchol(i+1);		//vytvoreni vrcholu
			
			System.out.println("\nZadejte sousedy vrchlu "+(i+1)+":");
			StringTokenizer radek=new StringTokenizer(nacti());
			int pocet=radek.countTokens();		//zjisteni poctu sousedu
			
			Vrchol pomSoused=graf.vrcholy[i];
			for(int j=0; j<pocet; j++){		//cyklus pro vytvoreni sousedu
				Vrchol soused=new Vrchol(Integer.parseInt(radek.nextToken()));
				pomSoused.dalsi=soused;
				pomSoused=soused;
			}
		}
	}
	
	public static void DFS(int cislo){		//vyhledavani do sirky
		System.out.print(cislo+" ");		//vypis nalezeneho vrcholu
		
		graf.vrcholy[cislo-1].barva='s';	//obarveni aktualniho vrcholu na sedo
		
		Vrchol pomVrchol=graf.vrcholy[cislo-1];
			
		while(pomVrchol.dalsi!=null){	//cyklus pro nalezeni vsech sousedu zkoumaneho vrcholu
			pomVrchol=pomVrchol.dalsi;
			int index=pomVrchol.cislo;
			if(graf.vrcholy[index-1].barva=='b'){
				DFS(index);		//hledani do hloubky od aktualniho souseda
			}
		}
			
		graf.vrcholy[cislo-1].barva='c';	//obarveni vrcholu na cerno (neni zadny bily soused)
	}
	
	public static String nacti(){	//nacteni radky (prevzato z http://online-judge.uva.es/)
		byte[]lin=new byte[100];
		int lg=0,car=-1;
		String line="";
		try{
			while(lg<100){
				car=System.in.read();
				if((car<0)||(car=='\n')){
					break;
				}
				lin[lg++]+=car;
			}
		}
        catch(IOException e){
			return(null);
		}
		if(car<0&&lg==0){
			return(null);
		}
		return(new String(lin,0,lg).trim());
	}
}

class Vrchol{		//trida Vrchol
	
	int cislo;
	char barva;
	Vrchol dalsi;
	
	Vrchol(int cislo){
		this.cislo=cislo;
	}
}

class Graf{		//trida graf - obsahuje seznam sousednosti
	
	Vrchol[] vrcholy;
	
	Graf(int cislo){
		vrcholy=new Vrchol[cislo];
	}
}